#!/bin/sh
############################################################################
#                                                                          #
#  Copyright (c) 2001, 2011 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of Medialogic S.p.A.                    #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################

COMMAND_ECHO="/bin/echo"

if [ $# -gt 8 -a $# -lt 4 ];
then
  $COMMAND_ECHO "NX> 599 Error: Wrong parameters count." && exit 1
fi 

if [ "x$1" != "xnx" -a "x$1" != "xroot" ];
then
  $COMMAND_ECHO "NX> 599 Error: nxquotaadd.sh: only 'nx' user can set a user quote by this script" 1>&2
  exit 1
fi

COMMAND_SETQUOTA="/usr/sbin/setquota"

if [ ! -x $COMMAND_SETQUOTA ];
then
  $COMMAND_ECHO "NX> 599 Error: command $COMMAND_SETQUOTA doesn't exist"
  exit 1
fi

if  [ $# -eq 4 ];
then
  if [ "x$3" != "x" ];
  then
    GUESTNAME="$3"
  fi 

  if [ "x$4" != "x" ];
  then
    PROTONAME="$4"
  fi 
  
  $COMMAND_SETQUOTA -u -p $PROTONAME $GUESTNAME -a
  exit $?
fi

if  [ $# -eq 8 ];
then
  if [ "x$3" != "x" ];
  then
    GUESTNAME="$3"
  fi 

  if [ "$8" != "all" ];
  then
    FS=$8
  else
    FS="-a"
  fi

  $COMMAND_SETQUOTA -u $GUESTNAME $4 $5 $6 $7 $FS
  exit $?
fi

if  [ $# -eq 6 ];
then
  if [ "x$3" != "x" ];
  then
    GUESTNAME="$3"
  fi 

  if [ "$6" != "all" ];
  then
    FS=$6
  else
    FS="-a"
  fi

  $COMMAND_SETQUOTA -T -u $GUESTNAME $4 $5 $FS
  exit $?
fi
