#!/bin/sh
############################################################################
#                                                                          #
#  Copyright (c) 2001, 2011 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of Medialogic S.p.A.                    #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################

NODE_ROOT='/usr/NX'

CONFIG_FILE="$NODE_ROOT/etc/server.cfg"

EX_USER=$1
EX_PID=$2
NXDISPLAY=$3
NXREMOTEIP=$4
NXUSER=$5

if test $# -ne 5 ; then
  echo "Wrong parameters count." && exit 1
fi

if [ "x$EX_USER" = "x" ];
then
  echo "username cannot be empty."
  exit 1  
elif [ "$EX_USER" != "nx" ];
then
  echo "Wrong username $EX_USER."
  exit 1
fi

if [ "x$NXDISPLAY" = "x" ];
then
  echo "ERROR: Argument display cannot be empty."
  exit 1
fi

if [ "x$NXREMOTEIP" = "x" ];
then
  echo "Argument address cannot be empty."
  exit 1
fi

if [ "x$NXUSER" = "x" ];
then
  echo "Argument username cannot be empty."
  exit 1
fi

tmp=`/usr/bin/awk -F'"' '/^CommandSessreg/ {print $2}' $CONFIG_FILE`

if [ "x$tmp" != "x" ];
then
  if [ -f $tmp ];
  then
    COMMAND_SESSREG=$tmp
  else
    echo "File '$tmp' doesnt exist" && exit 1
  fi
else
  echo "ERROR: Cannot update wtmp/utmp db: sessreg not defined" && exit 1
fi

if test ! -x $COMMAND_SESSREG ; then
  echo "Wrong PATH for sessreg binary." && exit 1
fi

exec $COMMAND_SESSREG -a -l "nx:$NXDISPLAY" -h $NXREMOTEIP $NXUSER
